<?php
	define('SM_PATH','../../');
	include_once(SM_PATH ."include/validate.php");
	include_once(SM_PATH ."functions/page_header.php");
	include_once(SM_PATH ."include/load_prefs.php");
	include_once(SM_PATH ."functions/global.php");

	$sa_score_dir = "/usr/local/share/spamassassin";

	$fp = popen("/bin/cat $sa_score_dir/??_*.cf","r");
	$order = array();
	while(!feof($fp))
	{
		$line = fgets($fp,1024);
		$line = preg_replace('/#.*/','',$line);
		$line = preg_replace('/^\s+/','',$line);
		$line = preg_replace('/\s+$/','',$line);
		$line = preg_replace('/\s+/',' ',$line);
		if ($line != NULL)
		{
			$bob = preg_split("/[\s,]+/",$line,3);
			switch ($bob[0])
			{
				case "describe" :
					$describe[$bob[1]]=$bob[2];
					$order[]=$bob[1];
					break;
				case "score" :
					$score[$bob[1]]=$bob[2];
					break;
				case "body" :
					$where[$bob[1]]="body";
					break;
				case "header" :
					$where[$bob[1]]="header";
					break;
				case "full" :
					$where[$bob[1]]="full";
					break;
				case "rawbody" :
					$where[$bob[1]]="rawbody";
					break;
				case "elsewhere" :
					$where[$bob[1]]="elsewhere";
			}
		}
	}
	pclose($fp);

	displayPageHeader($color, "None");   

	global $sa_spamassassin_name;
	global $sa;
	global $sac;
	global $sabl;
	global $sawl;

	load_spamassassin($username);

	$keep = array("defang_mime","required_hits","rewrite_header_subject",
		"rewrite_header_subject_tag",
		"report_header","use_terse_report",
		"procmail_enabled","procmail_delete",
		"subject_tag","required_hits","advanced",
		"report_safe","use_razor2","use_dcc","skip_rbl_checks",
		"ok_languages","bayes_auto_learn");
	while( list($x,$key) = each($keep))
	{
		if (isset($HTTP_POST_VARS["sa_$key"]))
		{
			$sa[$key] = $HTTP_POST_VARS["sa_$key"];
		}
	}

	if (isset($HTTP_POST_VARS["setbl"]))
	{
		$sabl = array();
		foreach (preg_split("/[\s,]+/", $HTTP_POST_VARS["setbl"]) as $a)
		{
			if (strlen($a)) $sabl[$a]=1;
		}
	}

	if (isset($HTTP_POST_VARS["setwl"]))
	{
		$sawl = array();
		foreach (preg_split("/[\s,]+/", $HTTP_POST_VARS["setwl"]) as $a)
		{
			if (strlen($a)) $sawl[$a]=1;
		}
	}

	// 6/27/2003 - eag : each($order) complains if $order is not an array
	// or object in our case, this was because $order is NULL.
	if ($order != NULL)
	{
		reset($order);
		while(list($x,$k) = each($order))
		{
			if (isset($_POST["sac_$k"])) $val = $HTTP_POST_VARS["sac_$k"];
				else $val = NULL;
			if ($val != NULL)
			{
				$sac[$k]=$val;
			}
			if (isset($sac[$k]))
			{
				if ($sac[$k] == $score[$k]) $sac[$k] = NULL;
			}
		}
	}

	if (isset($HTTP_POST_VARS["sa_save"]))
	{
		print "Saving preferences ... ";
		flush();
		save_spamassassin($username);
		print "Saved!<BR>\n<hr>\n";
	}

?>

<br>
<table width='95%' align=center border=0 cellpadding=2 cellspacing=0>
<tr>
	<td bgcolor="<?php echo $color[0] ?>">
	<center><b>Options - Spam Assassin</b></center>
	</td>
</tr>
</table>

<br>

<form method='post' action='options.php'>
<input type='hidden' name='sa_save' value='1'>

<table width='95%' align='center'>

<?PHP
	$name = "procmail_enabled";
	if ($sa[$name])
	{
		$ct = " checked"; $cf = "";
	}
	else
	{
		$ct = ""; $cf =" checked";
	}
	echo "<tr><td align=right><B>SpamAssassin enabled for <I>$username</I>:</B></td><td>" .
	"<INPUT$ct type=radio NAME=\"sa_$name\" value=\"1\"> Yes " . 
	"<INPUT$cf type=radio NAME=\"sa_$name\" value=\"0\"> No " . 
	"</td></tr>\n\n";

	$name = "procmail_delete";
	if ($sa[$name])
	{
		$ct = " checked"; $cf = "";
	}
	else
	{
		$ct = ""; $cf =" checked";
	}
	echo "<tr><td align=right><B>Delete marked spam automaticly:</B></td><td>" .
	"<INPUT$ct type=radio NAME=\"sa_$name\" value=\"1\"> Yes " . 
	"<INPUT$cf type=radio NAME=\"sa_$name\" value=\"0\"> No " . 
	"</td></tr>";
?>

<tr VALIGN=TOP><td align=right><B>Minimum score to mark as spam:</B><br>
5 is probably the best overall threshold.</td><td>
<?php
	$score_array = array(
		array("0","0 - Very Aggressive"),
		array("1","1"),
		array("2","2 - Aggressive"),
		array("3","3"),
		array("4","4"),
		array("5","5 - Recommended"),
		array("6","6"),
		array("7","7"),
		array("8","8 - Lenient"),
		array("9","9"),
		array("10","10 - Very Lenient"),
		array("99","99 - Don't Filter")
		);
	print("<SELECT NAME='sa_required_hits'>\n");
	foreach ($score_array as $bob)
	{
		print("\t<OPTION VALUE='". $bob[0] ."'");
		if ($bob[0] == $sa["required_hits"])
			print(" SELECTED");
		print(">". $bob[1] ."</OPTION>\n");
	}
	print("</SELECT>\n");
?>
</td></tr>


<tr><td align=right><B>Break (defang) MIME attachments on spam?</B></td><td>
<?PHP
	$name = "defang_mime";
	if ($sa[$name])
	{
		$ct = " checked"; $cf = "";
	}
	else
	{
		$ct = ""; $cf =" checked";
	}
  echo "<INPUT$ct type=radio NAME=\"sa_$name\" value=\"1\"> Yes " .
	"<INPUT$cf type=radio NAME=\"sa_$name\" value=\"0\"> No " .
	"</td></tr>\n\n";


	$name = "rewrite_header_subject";
	if ($sa[$name])
	{
		$ct = " checked"; $cf = "";
	}
	else
	{
		$ct = ""; $cf =" checked";
	}
  echo "<tr><td align=right><B>Mark subjects when spam?</B></td><td>".
	"<INPUT". $ct ." type=radio NAME=\"sa_". $name ."\" value=\"1\"> Yes ".
	"<INPUT". $cf ." type=radio NAME=\"sa_". $name ."\" value=\"0\"> No ".
	"</td></tr>";

  echo "<tr valign='top'><td align=right><B>Subject tag:</B><br>".
	"<tt>_HITS_</tt> will insert the spam score of the message.</td><td>";
	$string = htmlentities( $sa["rewrite_header_subject_tag"] );
	print("<input type=text name=\"sa_rewrite_header_subject_tag\" cols=50 value=\"".
		$string ."\">");
?>
</td></tr>


<tr VALIGN=TOP><td align=right><B>Report as header?</B><br>
Shows as a mail header instead of as a report.</td><td>
<?php
	$name = "report_header";
	if ($sa[$name])
	{
		$ct = " checked"; $cf = "";
	}
	else
	{
		$ct = ""; $cf =" checked";
	}
  echo "<INPUT$ct type=radio NAME=\"sa_$name\" value=\"1\"> Yes " .
	"<INPUT$cf type=radio NAME=\"sa_$name\" value=\"0\"> No " .
	"</td></tr>\n\n";


  echo "<tr VALIGN=TOP><td align=right><B>Make spam safe?</B><br>".
	"If a message is tagged as spam, create a new message and attach ".
	"the original as a message/rfc822 MIME attatchment.</td><td>";
	$name = "report_safe";
	if ($sa[$name])
	{
		$ct = " checked";
		$cf = "";
	}
	else
	{
		$ct = "";
		$cf =" checked";
	}
  echo "<INPUT$ct type=radio NAME=\"sa_$name\" value=\"1\"> Yes " .
	"<INPUT$cf type=radio NAME=\"sa_$name\" value=\"0\"> No " .
	"</td></tr>\n\n";


	$name = "use_terse_report";
	if ($sa[$name])
	{
		$ct = " checked"; $cf = "";
	}
	else
	{
		$ct = ""; $cf =" checked";
	}
  echo "<tr><td align=right><B>Make the report terse?</B></td><td>" .
       "<INPUT$ct type=radio NAME=\"sa_$name\" value=\"1\"> Yes " . 
       "<INPUT$cf type=radio NAME=\"sa_$name\" value=\"0\"> No " . 
       "</td></tr>";


	$name = "skip_rbl_checks";
	if ($sa[$name])
	{
		$ct = " checked"; $cf = "";
	}
	else
	{
		$ct = ""; $cf =" checked";
	}
  echo "<tr valign='top'><td align=right><B>Skip RBL checks?</B><br>".
	"We recommend against skipping the RBL checks.</td><td>" .
	"<INPUT$ct type=radio NAME=\"sa_$name\" value=\"1\"> Yes " . 
	"<INPUT$cf type=radio NAME=\"sa_$name\" value=\"0\"> No " . 
	"</td></tr>";


	$name = "use_dcc";
	if ($sa[$name])
	{
		$ct = " checked"; $cf = "";
	}
	else
	{
		$ct = ""; $cf =" checked";
	}
  echo "<tr valign='top'><td align=right><B>Use the DCC system?</B><br>".
	"We recommend that you use the Distrubuted Checksum Clearinghouse.</td><td>" .
	"<INPUT$ct type=radio NAME=\"sa_$name\" value=\"1\"> Yes " . 
	"<INPUT$cf type=radio NAME=\"sa_$name\" value=\"0\"> No " . 
	"</td></tr>";


	$name = "use_razor2";
	if ($sa[$name])
	{
		$ct = " checked"; $cf = "";
	}
	else
	{
		$ct = ""; $cf =" checked";
	}
  echo "<tr valign='top'><td align=right><B>Use the Razor2 system?</B><br>".
	"We recommend that you use Razor2 (SpamNet).</td><td>" .
	"<INPUT$ct type=radio NAME=\"sa_$name\" value=\"1\"> Yes " . 
	"<INPUT$cf type=radio NAME=\"sa_$name\" value=\"0\"> No " . 
	"</td></tr>";


	$name = "bayes_auto_learn";
	if ($sa[$name])
	{
		$ct = " checked"; $cf = "";
	}
	else
	{
		$ct = ""; $cf =" checked";
	}
  echo "<tr valign='top'><td align=right><B>Enable bayesian auto-learning?</B>".
	"</td><td>" .
	"<INPUT$ct type=radio NAME='sa_". $name ."' value=\"1\"> Yes " . 
	"<INPUT$cf type=radio NAME=\"sa_". $name ."\" value=\"0\"> No " . 
	"</td></tr>";
?>

<tr>
	<td>&nbsp;</td>
	<td><input type=submit value="Save Changes"></td>
</tr>

<tr VALIGN=TOP><td align=right>
<B>Whitelisted (<I>never block</I>) addresses:</B><br><BR>
You may put wildcards like <TT>*@isp.com</TT><br>
or <TT>*.domain.net</TT> if you wish.</td><td>
<?PHP 
	$string = "";
	if (count($sawl))
	{
		ksort($sawl);
		reset($sawl);
		while (list ($key, $val) = each ($sawl))
		{
			$string .= "$key\n";
		}
	}
	$string = htmlentities($string);
	print "<textarea name=setwl rows=10 cols=50>$string</textarea>";
?>
</td></tr>


<tr VALIGN=TOP><td align=right>
<B>Blacklisted (<I>always spam</I>) addresses:</B><br><BR>
You may put wildcards like <TT>*@isp.com</TT><br>
or <TT>*.domain.net</TT> if you wish.</td><td>
<?PHP 
	$string = "";
	if (count($sabl))
	{
		ksort($sabl);
		reset($sabl);
		while (list ($key, $val) = each ($sabl))
		{
			$string .= "$key\n";
		}
	}
	$string = htmlentities($string);
	print "<textarea name=setbl rows=10 cols=50>$string</textarea>";
?>
</td></tr>


<tr valign='top'><td align=right><B>Show advanced SpamAssassin score settings?</B><br>
Allows you to see and modify the scores used by all of the SA checks.  This
option is not recommended for most users.
</td><td>
<?PHP
	$name = "advanced";
	if ($sa[$name])
	{
		$ct = " checked"; $cf = "";
	}
	else
	{
		$ct = ""; $cf =" checked";
	}
	echo "<INPUT$ct type=radio NAME=\"sa_$name\" value=\"1\"> Yes " .
	"<INPUT$cf type=radio NAME=\"sa_$name\" value=\"0\"> No " .
	"</td></tr>";
?>

<tr>
	<td>&nbsp;</td>
	<td><input type=submit value="Save Changes"></td>
</tr>

<?PHP
	if ($sa["advanced"]>0)
	{
?>
<tr>
	<td colspan=2>
<p align='justify'>
The following will allow you to change the scores for each of the different
tests that SpamAssassin performs.  For more information about the various
tests, visit <A HREF='http://www.spamassassin.org/tests.html'
TARGET=SA>http://www.spamassassin.org/tests.html</A>.  Please note that if
you later change the above "Show advanced .." option from <i>Yes</i> to
<i>No</i> you will lose any changes you've made and will use the default
values instead.

<p>
<table align='center'>
<tr bgcolor="#dddddd"><th>Where</th><th>Description</th><th>Name</th><th>Score</th></tr>
<?PHP

if ($order != NULL)
{
	reset($order);
	$colors = array("#ffffff","#dddddd");
	while (list($k,$v) = each($order))
	{
		if (isset($sac[$v]))
		{
			$s = $sac[$v];
			$was = " &nbsp; (default is ". $score[$v] .")";
		}
		else
		{
			$was = "";
			if (isset($score[$v])) $s = $score[$v];
				else $s = NULL;
		}
		if (isset($where[$v])) $w = $where[$v];
			else $w = "elsewhere";
		if (isset($s))
		{
//			if (! $foofoo[$v]++)
//			{
				$color1 = array_shift($colors);
				$colors[] = $color1;
	print "<tr bgcolor='$color1' valign='top'><td><b>". $w ."</b></td>".
		"<td>". $describe[$v] ."</td>".
		"<td><font size='-1'>". $v ." ". $was ."</font></td>".
		"<td>";
	print "<input type=text size=10 name='sac_". $v ."' value='".
		$s ."'></td></tr>\n";
//			}
		}
	}
}
?>

</table>

	</td>
</tr>
<tr>	
	<td colspan='2' align='center'><input type=submit value="Save Changes"></td>
</tr>
<?PHP
	// End of if ($sa[advanced]) statement
	}
?>

<tr>
	<td colspan='2'>
Note that these changes affect new mail delivery - not existing mail. 
SpamAssassin is a delivery-time process, so that you don't have to wait for
it to process mail when you log in.
	</td>
</tr>
</table>

</form>


</body></html>
